//+------------------------------------------------------------------+
//|                                                       _Fast2.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 YellowGreen
#property indicator_color3 Red

extern int    ma1=3;
extern int    ma2=9;
extern bool   sound=true;
extern bool   alert=false;
extern bool   comment=true;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double tr[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   IndicatorBuffers(4);
  
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,ExtMapBuffer1);

   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer2);
   
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtMapBuffer3);

   SetIndexBuffer(3,tr);

   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
Comment("  ");    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){


   int limit=Bars-IndicatorCounted()-1;

   
      for(int i=limit;i>=0;i--){
         tr[i]=tr[i+1];
         ExtMapBuffer2[i]=0;
         ExtMapBuffer3[i]=0;         
         ExtMapBuffer1[i]=((Close[i]-Open[i])+((Close[i+1]-Open[i+1])/MathSqrt(2))+((Close[i+2]-Open[i+2])/MathSqrt(3)))/Point;       
         
            if(ExtMapBuffer1[i]>ExtMapBuffer1[i+1]){
               tr[i]=1;
            }
            if(ExtMapBuffer1[i]<ExtMapBuffer1[i+1]){
               tr[i]=-1;
            }   
            
            switch(tr[i]){
               case 1:
                  ExtMapBuffer2[i]=ExtMapBuffer1[i];
               break;
               case -1:
                  ExtMapBuffer3[i]=ExtMapBuffer1[i];               
               break;
            }
                     
      }

   
   
      
//----
   return(0);
  }
//+------------------------------------------------------------------+